import { ReadOnlyDictionary } from './ReadOnlyDictionary';
/**
 * Represents a collection of keys and values. Values can be accessed by keys.
 */
export declare class Dictionary<TKey, TValue> extends ReadOnlyDictionary<TKey, TValue> {
    add(key: TKey, value: TValue): this;
    asReadOnly(): ReadOnlyDictionary<TKey, TValue>;
    clear(): void;
    remove(key: TKey): boolean;
    set(key: TKey, value: TValue): this;
}
