var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ReadOnlyDictionary } from './ReadOnlyDictionary';
/**
 * Represents a collection of keys and values. Values can be accessed by keys.
 */
var Dictionary = /** @class */ (function (_super) {
    __extends(Dictionary, _super);
    function Dictionary() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Dictionary.prototype.add = function (key, value) {
        this.addInternal(key, value);
        return this;
    };
    Dictionary.prototype.asReadOnly = function () {
        return this;
    };
    Dictionary.prototype.clear = function () {
        this.innerDictionary.clear();
    };
    Dictionary.prototype.remove = function (key) {
        return this.innerDictionary.remove(key);
    };
    Dictionary.prototype.set = function (key, value) {
        this.innerDictionary.set(key, value);
        return this;
    };
    return Dictionary;
}(ReadOnlyDictionary));
export { Dictionary };
