import { ReadOnlyList } from './ReadOnlyList';
/**
 * Represents a list of objects that can be accessed by index.
 */
export declare class List<T> extends ReadOnlyList<T> {
    add(value: T): void;
    asReadOnly(): ReadOnlyList<T>;
    remove(index: number): void;
    set(index: number, value: T): void;
    clear(): void;
}
