import { Enumerable } from './Enumerable';
/**
 * Represents a stack of objects.
 */
export declare class Stack<T> extends Enumerable<T> {
    private readonly source;
    constructor(source?: Iterable<T>);
    [Symbol.iterator](): Iterator<T>;
    get size(): number;
    peek(): T;
    pop(): T;
    push(value: T): void;
    clear(): void;
}
