var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { Pair } from '../../models/Pair';
import { Enumerable } from '../Enumerable';
import { List } from '../List';
var EqualityComparerDictionary = /** @class */ (function () {
    function EqualityComparerDictionary(comparer) {
        this.buckets = new Map();
        this.sizeInternal = 0;
        this.comparer = comparer;
    }
    EqualityComparerDictionary.prototype[Symbol.iterator] = function () {
        var _a, _b, _c, bucket, bucket_1, bucket_1_1, pair, e_1_1, e_2_1;
        var e_2, _d, e_1, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    _f.trys.push([0, 11, 12, 13]);
                    _a = __values(this.buckets), _b = _a.next();
                    _f.label = 1;
                case 1:
                    if (!!_b.done) return [3 /*break*/, 10];
                    _c = __read(_b.value, 2), bucket = _c[1];
                    _f.label = 2;
                case 2:
                    _f.trys.push([2, 7, 8, 9]);
                    bucket_1 = (e_1 = void 0, __values(bucket)), bucket_1_1 = bucket_1.next();
                    _f.label = 3;
                case 3:
                    if (!!bucket_1_1.done) return [3 /*break*/, 6];
                    pair = bucket_1_1.value;
                    return [4 /*yield*/, pair];
                case 4:
                    _f.sent();
                    _f.label = 5;
                case 5:
                    bucket_1_1 = bucket_1.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (bucket_1_1 && !bucket_1_1.done && (_e = bucket_1.return)) _e.call(bucket_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 9:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 10: return [3 /*break*/, 13];
                case 11:
                    e_2_1 = _f.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 13];
                case 12:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 13: return [2 /*return*/];
            }
        });
    };
    EqualityComparerDictionary.prototype.clear = function () {
        this.buckets.clear();
        this.sizeInternal = 0;
    };
    EqualityComparerDictionary.prototype.containsKey = function (key) {
        var pair = this.getPair(key);
        return pair != null;
    };
    EqualityComparerDictionary.prototype.getPair = function (key) {
        var e_3, _a;
        var hashCode = this.comparer.getHashCode(key);
        var bucket = this.buckets.get(hashCode);
        if (bucket == null) {
            return undefined;
        }
        try {
            for (var bucket_2 = __values(bucket), bucket_2_1 = bucket_2.next(); !bucket_2_1.done; bucket_2_1 = bucket_2.next()) {
                var pair = bucket_2_1.value;
                if (this.comparer.equals(key, pair.key)) {
                    return pair;
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (bucket_2_1 && !bucket_2_1.done && (_a = bucket_2.return)) _a.call(bucket_2);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return undefined;
    };
    EqualityComparerDictionary.prototype.getSize = function () {
        return this.sizeInternal;
    };
    EqualityComparerDictionary.prototype.keys = function () {
        return Enumerable.from(this.buckets.values())
            .selectMany(function (x) { return Enumerable.from(x); })
            .select(function (x) { return x.key; });
    };
    EqualityComparerDictionary.prototype.remove = function (key) {
        var hashCode = this.comparer.getHashCode(key);
        var bucket = this.buckets.get(hashCode);
        if (bucket == null) {
            return false;
        }
        var removed = false;
        for (var i = 0; i < bucket.size; ++i) {
            var pair = bucket.get(i);
            if (this.comparer.equals(pair.key, key)) {
                bucket.remove(i);
                removed = true;
                --this.sizeInternal;
                break;
            }
        }
        if (bucket.size === 0) {
            this.buckets.delete(hashCode);
        }
        return removed;
    };
    EqualityComparerDictionary.prototype.set = function (key, value) {
        var hashCode = this.comparer.getHashCode(key);
        var bucket = this.buckets.get(hashCode);
        if (bucket == null) {
            bucket = new List();
            this.buckets.set(hashCode, bucket);
        }
        var set = false;
        for (var i = 0; i < bucket.size; ++i) {
            var pair = bucket.get(i);
            if (this.comparer.equals(pair.key, key)) {
                bucket.set(i, Pair.from(key, value));
                set = true;
                break;
            }
        }
        if (!set) {
            bucket.add(Pair.from(key, value));
            ++this.sizeInternal;
        }
    };
    EqualityComparerDictionary.prototype.values = function () {
        return Enumerable.from(this.buckets.values())
            .selectMany(function (x) { return Enumerable.from(x); })
            .select(function (x) { return x.value; });
    };
    return EqualityComparerDictionary;
}());
export { EqualityComparerDictionary };
