var SimpleHashSet = /** @class */ (function () {
    function SimpleHashSet() {
        this.source = new Set();
    }
    SimpleHashSet.prototype[Symbol.iterator] = function () {
        return this.source[Symbol.iterator]();
    };
    SimpleHashSet.prototype.clear = function () {
        this.source.clear();
    };
    SimpleHashSet.prototype.contains = function (element) {
        return this.source.has(element);
    };
    SimpleHashSet.prototype.getSize = function () {
        return this.source.size;
    };
    SimpleHashSet.prototype.remove = function (element) {
        return this.source.delete(element);
    };
    SimpleHashSet.prototype.set = function (element) {
        this.source.add(element);
    };
    return SimpleHashSet;
}());
export { SimpleHashSet };
