var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
// @ts-ignore
import equal from 'fast-deep-equal';
import stringify from 'fast-json-stable-stringify';
import { HashCode } from '../hashing/HashCode';
import { EqualityComparer } from './EqualityComparer';
var DeepEqualityComparer = /** @class */ (function (_super) {
    __extends(DeepEqualityComparer, _super);
    function DeepEqualityComparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DeepEqualityComparer.prototype.equals = function (value1, value2) {
        // tslint:disable-next-line:no-unsafe-any
        return equal(value1, value2);
    };
    DeepEqualityComparer.prototype.getHashCode = function (value) {
        var str = stringify(value, {
            cycles: false // this has to be false, because of compatibility with deepEqual
        });
        return HashCode.getHashCode(str);
    };
    return DeepEqualityComparer;
}(EqualityComparer));
export { DeepEqualityComparer };
