var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Comparer } from './Comparer';
var InverseComparer = /** @class */ (function (_super) {
    __extends(InverseComparer, _super);
    function InverseComparer(innerComparer) {
        var _this = _super.call(this) || this;
        _this.innerComparer = innerComparer;
        return _this;
    }
    InverseComparer.prototype.compare = function (value1, value2) {
        return -this.innerComparer.compare(value1, value2);
    };
    return InverseComparer;
}(Comparer));
export { InverseComparer };
