import { Comparer } from './Comparer';
export declare class SelectorComparer<T, TKey> extends Comparer<T> {
    private readonly keySelector;
    private readonly innerComparer;
    constructor(keySelector: (element: T) => TKey, innerComparer: Comparer<TKey>);
    compare(value1: T, value2: T): number;
}
