import { Enumerable } from '../collections/Enumerable';
import { EqualityComparer } from '../comparers/EqualityComparer';
export declare class ExceptEnumerable<T> extends Enumerable<T> {
    private readonly source;
    private readonly exceptSource;
    private readonly comparer?;
    constructor(source: Iterable<T>, exceptSource: Iterable<T>, comparer?: EqualityComparer<T> | undefined);
    [Symbol.iterator](): Iterator<T>;
}
