import { Enumerable } from '../collections/Enumerable';
import { Comparer } from '../comparers/Comparer';
export declare class ExtremaEnumerable<T, TKey> extends Enumerable<T> {
    private readonly source;
    private readonly keySelector;
    private readonly comparer;
    constructor(source: Iterable<T>, keySelector: (element: T, index: number) => TKey, comparer: Comparer<TKey>);
    [Symbol.iterator](): Iterator<T>;
}
