var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../collections/Enumerable';
import { List } from '../collections/List';
var ExtremaEnumerable = /** @class */ (function (_super) {
    __extends(ExtremaEnumerable, _super);
    function ExtremaEnumerable(source, keySelector, comparer) {
        var _this = _super.call(this) || this;
        _this.source = source;
        _this.keySelector = keySelector;
        _this.comparer = comparer;
        return _this;
    }
    ExtremaEnumerable.prototype[Symbol.iterator] = function () {
        var buffer, sourceWithKeys, sourceWithKeys_1, sourceWithKeys_1_1, pair, cmp, buffer_1, buffer_1_1, pair, e_1_1;
        var e_2, _a, e_1, _b;
        var _this = this;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    buffer = List.empty();
                    sourceWithKeys = Enumerable.from(this.source)
                        .select(function (element, idx) { return [element, _this.keySelector(element, idx)]; });
                    try {
                        for (sourceWithKeys_1 = __values(sourceWithKeys), sourceWithKeys_1_1 = sourceWithKeys_1.next(); !sourceWithKeys_1_1.done; sourceWithKeys_1_1 = sourceWithKeys_1.next()) {
                            pair = sourceWithKeys_1_1.value;
                            if (buffer.isEmpty()) {
                                buffer.add(pair);
                            }
                            else {
                                cmp = this.comparer.compare(buffer.first()[1], pair[1]);
                                if (cmp === 0) {
                                    buffer.add(pair);
                                }
                                else if (cmp < 0) {
                                    buffer.clear();
                                    buffer.add(pair);
                                }
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (sourceWithKeys_1_1 && !sourceWithKeys_1_1.done && (_a = sourceWithKeys_1.return)) _a.call(sourceWithKeys_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 6, 7, 8]);
                    buffer_1 = __values(buffer), buffer_1_1 = buffer_1.next();
                    _c.label = 2;
                case 2:
                    if (!!buffer_1_1.done) return [3 /*break*/, 5];
                    pair = buffer_1_1.value;
                    return [4 /*yield*/, pair[0]];
                case 3:
                    _c.sent();
                    _c.label = 4;
                case 4:
                    buffer_1_1 = buffer_1.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _c.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (buffer_1_1 && !buffer_1_1.done && (_b = buffer_1.return)) _b.call(buffer_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/];
            }
        });
    };
    return ExtremaEnumerable;
}(Enumerable));
export { ExtremaEnumerable };
