import { Enumerable } from '../collections/Enumerable';
export declare class MapEnumerable<TKey, TValue> extends Enumerable<[TKey, TValue]> {
    protected readonly source: Map<TKey, TValue>;
    constructor(source: Map<TKey, TValue>);
    [Symbol.iterator](): Iterator<[TKey, TValue]>;
}
