import { Enumerable } from '../collections/Enumerable';
export declare class SelectEnumerable<T, TResult> extends Enumerable<TResult> {
    private readonly source;
    private readonly selector;
    constructor(source: Iterable<T>, selector: (x: T, idx: number) => TResult);
    [Symbol.iterator](): Iterator<TResult>;
}
