import { Enumerable } from '../collections/Enumerable';
export declare class ZipEnumerable<TFirst, TSecond, TResult> extends Enumerable<TResult> {
    private readonly firstSource;
    private readonly secondSource;
    private readonly resultSelector;
    constructor(firstSource: Iterable<TFirst>, secondSource: Iterable<TSecond>, resultSelector: (first: TFirst, second: TSecond, index: number) => TResult);
    [Symbol.iterator](): Iterator<TResult>;
}
