import { EqualityComparer } from '../../../comparers/EqualityComparer';
import { Pair } from '../../../models/Pair';
declare module '../../../collections/Dictionary' {
    namespace Dictionary {
        /** Returns an Dictionary from rest parameters. */
        function fromRest<TKey, TValue>(...elements: Pair<TKey, TValue>[]): Dictionary<TKey, TValue>;
        /** Returns an Dictionary from rest parameters. */
        function fromRest<TKey, TValue>(comparer: EqualityComparer<TKey>, ...elements: Pair<TKey, TValue>[]): Dictionary<TKey, TValue>;
    }
}
