declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Applies an accumulator function over a sequence. */
        aggregate<TAccumulate = T, TResult = T>(this: Enumerable<T>, seed: TAccumulate, func: (acc: TAccumulate, value: T, index: number) => TAccumulate, resultSelector?: (a: TAccumulate) => TResult): TAccumulate | TResult;
    }
}
export {};
