var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../../collections/Enumerable';
import { Errors } from '../../Errors';
function elementAt(index) {
    var e_1, _a;
    if (index < 0) {
        throw Errors.indexOutOfRange();
    }
    var idx = 0;
    try {
        for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
            var element = _c.value;
            if (idx === index) {
                return element;
            }
            ++idx;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    throw Errors.indexOutOfRange();
}
Enumerable.prototype.elementAt = elementAt;
