declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the first element of a sequence, or undefined if the sequence contains no elements. */
        firstOrDefault(predicate?: (x: T, index: number) => boolean): T | undefined;
    }
}
export {};
