declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the last element of a sequence that satisfies a condition or undefined if no such element is found. */
        lastOrDefault(predicate?: (x: T, index: number) => boolean): T | undefined;
    }
}
export {};
