declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Invokes a transform function on each element of a sequence and returns the minimum value. */
        min(selector?: (element: T, index: number) => number): number;
    }
}
export {};
