import { Enumerable } from '../../collections/Enumerable';
import { Comparer } from '../../comparers/Comparer';
import { ExtremaEnumerable } from '../../enumerables/ExtremaEnumerable';
function minBy(keySelector, comparer) {
    if (comparer === void 0) { comparer = Comparer.getDefault(); }
    return new ExtremaEnumerable(this, keySelector, Comparer.invert(comparer));
}
Enumerable.prototype.minBy = minBy;
