import { Enumerable } from '../../collections/Enumerable';
import { Comparer } from '../../comparers/Comparer';
function orderByDescending(keySelector, comparer) {
    if (comparer === void 0) { comparer = Comparer.getDefault(); }
    return this.orderBy(keySelector, comparer, true);
}
Enumerable.prototype.orderByDescending = orderByDescending;
