declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the only element of a sequence that satisfies a specified condition, and throws an exception if more than one such element exists. */
        single(predicate?: (x: T, index: number) => boolean): T;
    }
}
export {};
