declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Computes the sum of the sequence that are obtained by invoking a transform function on each element of the input sequence. */
        sum(selector?: (element: T, index: number) => number): number;
    }
}
export {};
