declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns elements from a sequence as long as a specified condition is true. */
        takeWhile(predicate: (element: T, index: number) => boolean): Enumerable<T>;
    }
}
export {};
