declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Converts sequence to a ReadOnlyMap. */
        toReadOnlyMap<TKey, TValue = T>(keySelector: (element: T, index: number) => TKey, valueSelector?: (element: T, index: number) => TValue): ReadonlyMap<TKey, TValue>;
    }
}
export {};
