declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Filters a sequence of values based on a predicate. */
        where(predicate: (element: T, index: number) => boolean): Enumerable<T>;
    }
}
export {};
