import { ZipElement } from '../../models/ZipElement';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Applies a specified function to the corresponding elements of two sequences, producing a sequence of the results. */
        zip<TSecond, TResult = ZipElement<T, TSecond>>(second: Iterable<TSecond>, resultSelector?: (first: T, second: TSecond, index: number) => TResult): Enumerable<TResult>;
    }
}
