import { EqualityComparer } from '../../../comparers/EqualityComparer';
import { SelectorEqualityComparer } from '../../../comparers/SelectorEqualityComparer';
function fromSelector(selector, innerComparer) {
    var comparer = innerComparer !== null && innerComparer !== void 0 ? innerComparer : EqualityComparer.getDefault();
    return new SelectorEqualityComparer(selector, comparer);
}
EqualityComparer.fromSelector = fromSelector;
