import { EqualityComparer } from '../../../comparers/EqualityComparer';
declare module '../../../collections/ReadOnlyDictionary' {
    namespace ReadOnlyDictionary {
        /** Returns an ReadOnlyDictionary sequence containing exactly one value. */
        function single<TKey, TValue>(key: TKey, value: TValue, comparer?: EqualityComparer<TKey>): ReadOnlyDictionary<TKey, TValue>;
    }
}
