var Errors = /** @class */ (function () {
    function Errors() {
    }
    Errors.argumentOutOfRange = function () {
        return new Error('Argument was out of range');
    };
    Errors.indexOutOfRange = function () {
        return new Error('Index was out of range');
    };
    Errors.indexNotInteger = function () {
        return new Error('Index was not an integer');
    };
    Errors.itemWithKeyAlreadyAdded = function () {
        return new Error('An item with the same key has already been added');
    };
    Errors.elementAlreadyAdded = function () {
        return new Error('The element has already been added');
    };
    Errors.keyNotInDictionary = function () {
        return new Error('The given key was not present in the dictionary');
    };
    Errors.linkedListEmpty = function () {
        return new Error('LinkedList is empty');
    };
    Errors.noElements = function () {
        return new Error('Sequence contains no elements');
    };
    Errors.noMatch = function () {
        return new Error('Sequence contains no matching element');
    };
    Errors.moreThanOneMatch = function () {
        return new Error('Sequence contains more than one element');
    };
    Errors.moreThanOneElement = function () {
        return new Error('Sequence contains more than one matching element');
    };
    Errors.stackEmpty = function () {
        return new Error('Stack is empty');
    };
    Errors.queueEmpty = function () {
        return new Error('Queue is empty');
    };
    Errors.unexpectedError = function () {
        return new Error('Unexpected error');
    };
    Errors.valueIsNotNumber = function () {
        return new TypeError('Value is not a number');
    };
    Errors.valueNotFoundLinkedList = function () {
        return new Error('The value is not present in LinkedList');
    };
    return Errors;
}());
export { Errors };
