import { ReadOnlyHashSet } from './ReadOnlyHashSet';
/**
 * Represents a set of values.
 */
export declare class HashSet<T> extends ReadOnlyHashSet<T> {
    add(element: T): this;
    asReadOnly(): ReadOnlyHashSet<T>;
    clear(): void;
    remove(element: T): boolean;
    set(element: T): this;
}
