var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { ReadOnlyHashSet } from './ReadOnlyHashSet';
/**
 * Represents a set of values.
 */
var HashSet = /** @class */ (function (_super) {
    __extends(HashSet, _super);
    function HashSet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HashSet.prototype.add = function (element) {
        this.addInternal(element);
        return this;
    };
    HashSet.prototype.asReadOnly = function () {
        return this;
    };
    HashSet.prototype.clear = function () {
        this.internalHashSet.clear();
    };
    HashSet.prototype.remove = function (element) {
        return this.internalHashSet.remove(element);
    };
    HashSet.prototype.set = function (element) {
        this.internalHashSet.set(element);
        return this;
    };
    return HashSet;
}(ReadOnlyHashSet));
export { HashSet };
