import { Enumerable } from './Enumerable';
import { Grouping } from './Grouping';
import { ReadOnlyDictionary } from './ReadOnlyDictionary';
export declare class Lookup<TKey, TElement> extends Enumerable<Grouping<TKey, TElement>> {
    private readonly dict;
    constructor(dict: ReadOnlyDictionary<TKey, Grouping<TKey, TElement>>);
    [Symbol.iterator](): Iterator<Grouping<TKey, TElement>>;
    containsKey(key: TKey): boolean;
    get(key: TKey): Grouping<TKey, TElement>;
    getOrDefault(key: TKey): Grouping<TKey, TElement> | undefined;
}
