import { ArrayEnumerable } from '../enumerables/ArrayEnumerable';
/**
 * Represents a read-only linked list of objects.
 */
export declare class ReadOnlyList<T> extends ArrayEnumerable<T> {
    constructor(source?: Iterable<T>);
    get size(): number;
    containsIndex(index: number): boolean;
    get(index: number): T;
    getOrDefault(index: number): T | undefined;
}
