import { EqualityComparer } from '../../comparers/EqualityComparer';
import { List } from '../List';
import { HashSetAbstraction } from './HashSetAbstraction';
export declare class EqualityComparerHashSet<T> implements HashSetAbstraction<T> {
    protected readonly buckets: Map<number, List<T>>;
    protected readonly comparer: EqualityComparer<T>;
    protected sizeInternal: number;
    constructor(comparer: EqualityComparer<T>);
    [Symbol.iterator](): Iterator<T>;
    clear(): void;
    contains(element: T): boolean;
    getSize(): number;
    remove(element: T): boolean;
    set(element: T): void;
}
