import { HashSetAbstraction } from './HashSetAbstraction';
export declare class SelectorEqualityHashSet<T, TKeySelector> implements HashSetAbstraction<T> {
    private readonly keySelector;
    private readonly source;
    constructor(keySelector: (key: T) => TKeySelector);
    [Symbol.iterator](): Iterator<T>;
    clear(): void;
    contains(element: T): boolean;
    getSize(): number;
    remove(element: T): boolean;
    set(element: T): void;
}
