import { HashSetAbstraction } from './HashSetAbstraction';
export declare class SimpleHashSet<T> implements HashSetAbstraction<T> {
    private readonly source;
    [Symbol.iterator](): Iterator<T>;
    clear(): void;
    contains(element: T): boolean;
    getSize(): number;
    remove(element: T): boolean;
    set(element: T): void;
}
