var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { HashCode } from '../hashing/HashCode';
import { EqualityComparer } from './EqualityComparer';
var DefaultEqualityComparer = /** @class */ (function (_super) {
    __extends(DefaultEqualityComparer, _super);
    function DefaultEqualityComparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultEqualityComparer.prototype.equals = function (value1, value2) {
        return value1 === value2;
    };
    DefaultEqualityComparer.prototype.getHashCode = function (value) {
        return HashCode.getHashCode(value);
    };
    return DefaultEqualityComparer;
}(EqualityComparer));
export { DefaultEqualityComparer };
