import { EqualityComparer } from './EqualityComparer';
export declare class PredicateEqualityComparer<T> extends EqualityComparer<T> {
    private readonly predicate;
    private readonly getHashCodeFunc?;
    constructor(predicate: (value1: T, value2: T) => boolean, getHashCodeFunc?: ((value: T) => number) | undefined);
    equals(value1: T, value2: T): boolean;
    getHashCode(value: T): number;
}
