import { EqualityComparer } from './EqualityComparer';
export declare class SelectorEqualityComparer<TSource, TKey> extends EqualityComparer<TSource> {
    readonly keySelector: (value: TSource) => TKey;
    readonly innerComparer: EqualityComparer<TKey>;
    constructor(keySelector: (value: TSource) => TKey, innerComparer: EqualityComparer<TKey>);
    equals(value1: TSource, value2: TSource): boolean;
    getHashCode(value: TSource): number;
}
