var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EqualityComparer } from './EqualityComparer';
var SelectorEqualityComparer = /** @class */ (function (_super) {
    __extends(SelectorEqualityComparer, _super);
    function SelectorEqualityComparer(keySelector, innerComparer) {
        var _this = _super.call(this) || this;
        _this.keySelector = keySelector;
        _this.innerComparer = innerComparer;
        return _this;
    }
    SelectorEqualityComparer.prototype.equals = function (value1, value2) {
        return this.innerComparer.equals(this.keySelector(value1), this.keySelector(value2));
    };
    SelectorEqualityComparer.prototype.getHashCode = function (value) {
        return this.innerComparer.getHashCode(this.keySelector(value));
    };
    return SelectorEqualityComparer;
}(EqualityComparer));
export { SelectorEqualityComparer };
