import { Enumerable } from '../collections/Enumerable';
import { EqualityComparer } from '../comparers/EqualityComparer';
export declare class DistinctByEnumerable<T, TKey = T> extends Enumerable<T> {
    private readonly source;
    private readonly keySelector?;
    private readonly comparer?;
    constructor(source: Iterable<T>, keySelector?: ((element: T, index: number) => TKey) | undefined, comparer?: EqualityComparer<TKey> | undefined);
    [Symbol.iterator](): Iterator<T>;
}
