var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../collections/Enumerable';
import { FullJoinElement } from '../models/FullJoinElement';
var FullJoinEnumerable = /** @class */ (function (_super) {
    __extends(FullJoinEnumerable, _super);
    function FullJoinEnumerable(leftSource, rightSource, leftKeySelector, rightKeySelector, resultSelector) {
        var _this = _super.call(this) || this;
        _this.leftSource = leftSource;
        _this.rightSource = rightSource;
        _this.leftKeySelector = leftKeySelector;
        _this.rightKeySelector = rightKeySelector;
        _this.resultSelector = resultSelector;
        return _this;
    }
    FullJoinEnumerable.prototype[Symbol.iterator] = function () {
        var leftEnumerable, rightEnumerable, leftLookup, rightLookup, selector, leftLookup_1, leftLookup_1_1, leftGroup, rightGroup, leftGroup_1, leftGroup_1_1, left, rightGroup_1, rightGroup_1_1, right, e_1_1, e_2_1, e_3_1, rightLookup_1, rightLookup_1_1, rightGroup, rightGroup_2, rightGroup_2_1, right, e_4_1, e_5_1;
        var e_3, _a, e_2, _b, e_1, _c, e_5, _d, e_4, _e;
        var _f;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    leftEnumerable = Enumerable.from(this.leftSource);
                    rightEnumerable = Enumerable.from(this.rightSource);
                    leftLookup = leftEnumerable.toLookup(this.leftKeySelector);
                    rightLookup = rightEnumerable.toLookup(this.rightKeySelector);
                    selector = (_f = this.resultSelector) !== null && _f !== void 0 ? _f : (function (left, right) { return new FullJoinElement(left, right); });
                    _g.label = 1;
                case 1:
                    _g.trys.push([1, 21, 22, 23]);
                    leftLookup_1 = __values(leftLookup), leftLookup_1_1 = leftLookup_1.next();
                    _g.label = 2;
                case 2:
                    if (!!leftLookup_1_1.done) return [3 /*break*/, 20];
                    leftGroup = leftLookup_1_1.value;
                    rightGroup = rightLookup.getOrDefault(leftGroup.key);
                    _g.label = 3;
                case 3:
                    _g.trys.push([3, 17, 18, 19]);
                    leftGroup_1 = (e_2 = void 0, __values(leftGroup)), leftGroup_1_1 = leftGroup_1.next();
                    _g.label = 4;
                case 4:
                    if (!!leftGroup_1_1.done) return [3 /*break*/, 16];
                    left = leftGroup_1_1.value;
                    if (!(rightGroup != null)) return [3 /*break*/, 13];
                    _g.label = 5;
                case 5:
                    _g.trys.push([5, 10, 11, 12]);
                    rightGroup_1 = (e_1 = void 0, __values(rightGroup)), rightGroup_1_1 = rightGroup_1.next();
                    _g.label = 6;
                case 6:
                    if (!!rightGroup_1_1.done) return [3 /*break*/, 9];
                    right = rightGroup_1_1.value;
                    return [4 /*yield*/, selector(left, right)];
                case 7:
                    _g.sent();
                    _g.label = 8;
                case 8:
                    rightGroup_1_1 = rightGroup_1.next();
                    return [3 /*break*/, 6];
                case 9: return [3 /*break*/, 12];
                case 10:
                    e_1_1 = _g.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 11:
                    try {
                        if (rightGroup_1_1 && !rightGroup_1_1.done && (_c = rightGroup_1.return)) _c.call(rightGroup_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 12: return [3 /*break*/, 15];
                case 13: return [4 /*yield*/, selector(left, undefined)];
                case 14:
                    _g.sent();
                    _g.label = 15;
                case 15:
                    leftGroup_1_1 = leftGroup_1.next();
                    return [3 /*break*/, 4];
                case 16: return [3 /*break*/, 19];
                case 17:
                    e_2_1 = _g.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 19];
                case 18:
                    try {
                        if (leftGroup_1_1 && !leftGroup_1_1.done && (_b = leftGroup_1.return)) _b.call(leftGroup_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 19:
                    leftLookup_1_1 = leftLookup_1.next();
                    return [3 /*break*/, 2];
                case 20: return [3 /*break*/, 23];
                case 21:
                    e_3_1 = _g.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 23];
                case 22:
                    try {
                        if (leftLookup_1_1 && !leftLookup_1_1.done && (_a = leftLookup_1.return)) _a.call(leftLookup_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 23:
                    _g.trys.push([23, 34, 35, 36]);
                    rightLookup_1 = __values(rightLookup), rightLookup_1_1 = rightLookup_1.next();
                    _g.label = 24;
                case 24:
                    if (!!rightLookup_1_1.done) return [3 /*break*/, 33];
                    rightGroup = rightLookup_1_1.value;
                    if (!!leftLookup.containsKey(rightGroup.key)) return [3 /*break*/, 32];
                    _g.label = 25;
                case 25:
                    _g.trys.push([25, 30, 31, 32]);
                    rightGroup_2 = (e_4 = void 0, __values(rightGroup)), rightGroup_2_1 = rightGroup_2.next();
                    _g.label = 26;
                case 26:
                    if (!!rightGroup_2_1.done) return [3 /*break*/, 29];
                    right = rightGroup_2_1.value;
                    return [4 /*yield*/, selector(undefined, right)];
                case 27:
                    _g.sent();
                    _g.label = 28;
                case 28:
                    rightGroup_2_1 = rightGroup_2.next();
                    return [3 /*break*/, 26];
                case 29: return [3 /*break*/, 32];
                case 30:
                    e_4_1 = _g.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 32];
                case 31:
                    try {
                        if (rightGroup_2_1 && !rightGroup_2_1.done && (_e = rightGroup_2.return)) _e.call(rightGroup_2);
                    }
                    finally { if (e_4) throw e_4.error; }
                    return [7 /*endfinally*/];
                case 32:
                    rightLookup_1_1 = rightLookup_1.next();
                    return [3 /*break*/, 24];
                case 33: return [3 /*break*/, 36];
                case 34:
                    e_5_1 = _g.sent();
                    e_5 = { error: e_5_1 };
                    return [3 /*break*/, 36];
                case 35:
                    try {
                        if (rightLookup_1_1 && !rightLookup_1_1.done && (_d = rightLookup_1.return)) _d.call(rightLookup_1);
                    }
                    finally { if (e_5) throw e_5.error; }
                    return [7 /*endfinally*/];
                case 36: return [2 /*return*/];
            }
        });
    };
    return FullJoinEnumerable;
}(Enumerable));
export { FullJoinEnumerable };
