var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Enumerable } from '../collections/Enumerable';
import { JoinElement } from '../models/JoinElement';
var LeftJoinEnumerable = /** @class */ (function (_super) {
    __extends(LeftJoinEnumerable, _super);
    function LeftJoinEnumerable(leftSource, rightSource, leftKeySelector, rightKeySelector, resultSelector) {
        var _this = _super.call(this) || this;
        _this.leftSource = leftSource;
        _this.rightSource = rightSource;
        _this.leftKeySelector = leftKeySelector;
        _this.rightKeySelector = rightKeySelector;
        _this.resultSelector = resultSelector;
        return _this;
    }
    LeftJoinEnumerable.prototype[Symbol.iterator] = function () {
        var rightEnumerable, rightLookup, selector, index, _a, _b, left, key, rightGroup, rightGroup_1, rightGroup_1_1, right, e_1_1, e_2_1;
        var e_2, _c, e_1, _d;
        var _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    rightEnumerable = Enumerable.from(this.rightSource);
                    rightLookup = rightEnumerable.toLookup(this.rightKeySelector);
                    selector = (_e = this.resultSelector) !== null && _e !== void 0 ? _e : (function (left, right) { return new JoinElement(left, right); });
                    index = 0;
                    _f.label = 1;
                case 1:
                    _f.trys.push([1, 13, 14, 15]);
                    _a = __values(this.leftSource), _b = _a.next();
                    _f.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 12];
                    left = _b.value;
                    key = this.leftKeySelector(left, index++);
                    rightGroup = rightLookup.getOrDefault(key);
                    if (!(rightGroup == null)) return [3 /*break*/, 4];
                    return [4 /*yield*/, selector(left, undefined)];
                case 3:
                    _f.sent();
                    return [3 /*break*/, 11];
                case 4:
                    _f.trys.push([4, 9, 10, 11]);
                    rightGroup_1 = (e_1 = void 0, __values(rightGroup)), rightGroup_1_1 = rightGroup_1.next();
                    _f.label = 5;
                case 5:
                    if (!!rightGroup_1_1.done) return [3 /*break*/, 8];
                    right = rightGroup_1_1.value;
                    return [4 /*yield*/, selector(left, right)];
                case 6:
                    _f.sent();
                    _f.label = 7;
                case 7:
                    rightGroup_1_1 = rightGroup_1.next();
                    return [3 /*break*/, 5];
                case 8: return [3 /*break*/, 11];
                case 9:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 11];
                case 10:
                    try {
                        if (rightGroup_1_1 && !rightGroup_1_1.done && (_d = rightGroup_1.return)) _d.call(rightGroup_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 11:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 12: return [3 /*break*/, 15];
                case 13:
                    e_2_1 = _f.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 15];
                case 14:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 15: return [2 /*return*/];
            }
        });
    };
    return LeftJoinEnumerable;
}(Enumerable));
export { LeftJoinEnumerable };
