import { OrderedEnumerable } from '../collections/OrderedEnumerable';
import { Comparer } from '../comparers/Comparer';
export declare class OrderedEnumerableInner<T, TKey> extends OrderedEnumerable<T> {
    private readonly source;
    private readonly keySelector;
    private readonly comparer;
    constructor(source: Iterable<T>, keySelector: (element: T) => TKey, comparer: Comparer<TKey>);
    [Symbol.iterator](): Iterator<T>;
    thenBy<TInnerKey>(keySelector: (element: T) => TInnerKey, comparer?: Comparer<TInnerKey>, descending?: boolean): OrderedEnumerable<T>;
    thenByDescending<TInnerKey>(keySelector: (element: T) => TInnerKey, comparer?: Comparer<TInnerKey>): OrderedEnumerable<T>;
}
