import { Enumerable } from '../collections/Enumerable';
export declare class WhereEnumerable<T> extends Enumerable<T> {
    private readonly source;
    private readonly predicate;
    constructor(source: Iterable<T>, predicate: (item: T, index: number) => boolean);
    [Symbol.iterator](): Iterator<T>;
}
