import { EqualityComparer } from '../../../comparers/EqualityComparer';
declare module '../../../collections/Dictionary' {
    namespace Dictionary {
        /** Returns an Dictionary sequence containing exactly one value. */
        function single<TKey, TValue>(key: TKey, value: TValue, comparer?: EqualityComparer<TKey>): Dictionary<TKey, TValue>;
    }
}
