declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns a number that represents how many elements in the specified sequence satisfy a condition. */
        count<T>(predicate?: (element: T, index: number) => boolean): number;
    }
}
export {};
