import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns distinct elements from a sequence by using key selector to compare values. */
        distinctBy<TKey = T>(keySelector: (element: T, index: number) => TKey, comparer?: EqualityComparer<TKey>): Enumerable<T>;
    }
}
