declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the element at a specified index in a sequence or a default value if the index is out of range. */
        elementAtOrDefault<T>(index: number): T | undefined;
    }
}
export {};
