import { Enumerable } from '../../collections/Enumerable';
import { EqualityComparer } from '../../comparers/EqualityComparer';
import { GroupByEnumerable } from '../../enumerables/GroupByEnumerable';
function groupBy(keySelector, a, b, c) {
    var keyEqualityComparer;
    var elementSelector;
    var resultSelector;
    if (a instanceof EqualityComparer) {
        keyEqualityComparer = a;
        elementSelector = b;
        resultSelector = c;
    }
    else {
        keyEqualityComparer = undefined;
        elementSelector = a;
        resultSelector = b;
    }
    return new GroupByEnumerable(this, keySelector, keyEqualityComparer, elementSelector, resultSelector);
}
Enumerable.prototype.groupBy = groupBy;
