declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the last element of a sequence that satisfies a specified condition. */
        last(predicate?: (x: T, index: number) => boolean): T;
    }
}
export {};
