import { Comparer } from '../../comparers/Comparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the maximal elements of the given sequence, based on the given projection. */
        maxBy<TKey>(keySelector: (element: T, index: number) => TKey, comparer?: Comparer<TKey>): Enumerable<T>;
    }
}
