import { Comparer } from '../../comparers/Comparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Returns the minimal elements of the given sequence, based on the given projection. */
        minBy<TKey>(keySelector: (element: T, index: number) => TKey, comparer?: Comparer<TKey>): Enumerable<T>;
    }
}
