import { OrderedEnumerable } from '../../collections/OrderedEnumerable';
import { Comparer } from '../../comparers/Comparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Sorts the elements of a sequence according to a key. */
        orderBy<TKey>(keySelector: (element: T) => TKey, comparer?: Comparer<TKey>, descending?: boolean): OrderedEnumerable<T>;
    }
}
