import { Enumerable } from '../../collections/Enumerable';
import { Comparer } from '../../comparers/Comparer';
import { OrderedEnumerableInner } from '../../enumerables/OrderedEnumerableInner';
function orderBy(keySelector, comparer, descending) {
    if (comparer === void 0) { comparer = Comparer.getDefault(); }
    if (descending === void 0) { descending = false; }
    var newComparer = Comparer.invert(comparer, descending);
    return new OrderedEnumerableInner(this, keySelector, newComparer);
}
Enumerable.prototype.orderBy = orderBy;
