import { OrderedEnumerable } from '../../collections/OrderedEnumerable';
import { Comparer } from '../../comparers/Comparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Sorts the elements of a sequence in descending order according to a key. */
        orderByDescending<TKey>(keySelector: (element: T) => TKey, comparer?: Comparer<TKey>): OrderedEnumerable<T>;
    }
}
