declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Projects each element of a sequence into a new form. */
        select<TResult>(selector: (x: T, index: number) => TResult): Enumerable<TResult>;
    }
}
export {};
