import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Determines whether two sequences are equal by comparing the elements. */
        sequenceEqual(secondSource: Iterable<T>, comparer?: EqualityComparer<T>): boolean;
    }
}
