import { HashSet } from '../../collections/HashSet';
import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Converts sequence to a HashSet. */
        toHashSet(comparer?: EqualityComparer<T>): HashSet<T>;
    }
}
