import { Enumerable } from '../../collections/Enumerable';
import { Lookup } from '../../collections/Lookup';
function toLookup(keySelector, valueSelector) {
    var dict = this
        .groupBy(keySelector, valueSelector)
        .toReadOnlyDictionary(function (x) { return x.key; });
    return new Lookup(dict);
}
Enumerable.prototype.toLookup = toLookup;
