import { ReadOnlyHashSet } from '../../collections/ReadOnlyHashSet';
import { EqualityComparer } from '../../comparers/EqualityComparer';
declare module '../../collections/Enumerable' {
    interface Enumerable<T> {
        /** Converts sequence to a ReadOnlyHashSet. */
        toReadOnlyHashSet(comparer?: EqualityComparer<T>): ReadOnlyHashSet<T>;
    }
}
