import { EqualityComparer } from '../../../comparers/EqualityComparer';
import { Pair } from '../../../models/Pair';
declare module '../../../collections/ReadOnlyDictionary' {
    namespace ReadOnlyDictionary {
        /** Returns an ReadOnlyDictionary from rest parameters. */
        function fromRest<TKey, TValue>(...elements: Pair<TKey, TValue>[]): ReadOnlyDictionary<TKey, TValue>;
        /** Returns an ReadOnlyDictionary from rest parameters. */
        function fromRest<TKey, TValue>(comparer: EqualityComparer<TKey>, ...elements: Pair<TKey, TValue>[]): ReadOnlyDictionary<TKey, TValue>;
    }
}
