var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
import { Dictionary } from '../../../collections/Dictionary';
import { ReadOnlyDictionary } from '../../../collections/ReadOnlyDictionary';
import { EqualityComparer } from '../../../comparers/EqualityComparer';
function fromRest(comparer) {
    var elements = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        elements[_i - 1] = arguments[_i];
    }
    if (comparer != null && comparer instanceof EqualityComparer) {
        return new Dictionary(elements, comparer);
    }
    return new Dictionary(__spreadArray([comparer], __read(elements))); // TODO undefined
}
ReadOnlyDictionary.fromRest = fromRest;
