import { Enumerable } from '../../../collections/Enumerable';
import { ReadOnlyDictionary } from '../../../collections/ReadOnlyDictionary';
import { Pair } from '../../../models/Pair';
function single(key, value, comparer) {
    return new ReadOnlyDictionary(Enumerable.single(Pair.from(key, value)), comparer);
}
ReadOnlyDictionary.single = single;
