import { EqualityComparer } from '../../../comparers/EqualityComparer';
declare module '../../../collections/ReadOnlyHashSet' {
    namespace ReadOnlyHashSet {
        /** Returns an ReadOnlyHashSet from rest parameters. */
        function fromRest<T>(...elements: T[]): ReadOnlyHashSet<T>;
        /** Returns an HashSet from rest parameters. */
        function fromRest<T>(comparer?: EqualityComparer<T>, ...elements: T[]): ReadOnlyHashSet<T>;
    }
}
