import { LinkedList } from '../collections/LinkedList';
import { LinkedListNode } from './LinkedListNode';
export declare class LinkedListNodeInternal<TValue> extends LinkedListNode<TValue> {
    valueInternal: TValue;
    readonly linkedList: LinkedList<TValue>;
    previousInternal?: LinkedListNodeInternal<TValue> | undefined;
    nextInternal?: LinkedListNodeInternal<TValue> | undefined;
    constructor(valueInternal: TValue, linkedList: LinkedList<TValue>, previousInternal?: LinkedListNodeInternal<TValue> | undefined, nextInternal?: LinkedListNodeInternal<TValue> | undefined);
    get value(): TValue;
    set value(val: TValue);
    get previous(): LinkedListNode<TValue> | undefined;
    get next(): LinkedListNode<TValue> | undefined;
}
